
#define _CRT_SECURE_NO_WARNINGS


//#include "stdafx.h"
#include <stdio.h>
#include <tchar.h>
#include "c1541.h"
#include "term.h"


extern unsigned char* Read_C64(int,int);
extern void Write_C64(unsigned char*,int,int);


#define	TRACK_AREAS				4
#define FIRST_TRACK				1
#define	END_TRACK				36
long TRACK_AREA_FirstTrack[] 			= { 1,18,25,31,END_TRACK };
long TRACK_AREA_SectorsPerTrack[] 	= { 21,19,18,17 };
long TRACK_AREA_Tracks[]			 	= { 17,7,6,5 };
long TRACK_AREA_Blocks[]				= { 357,133,108,85 };
long TRACK_AREA_LogicalStartPosition[]		= { 0,91392,125440,153088 };


#define	BUS_IGNORE						0
#define	BUS_TO_DISK_IO					1
#define	BUS_TO_BUFFER					2
#define	BUS_TO_WORK_BUFFER			3
#define	DISK_IO_TO_BUS					4
#define	BUFFER_TO_BUS					5
#define	WORK_BUFFER_TO_BUS			6
#define	DIRECTORY_TO_BUS				7


/*struct pc_file_error
{
	long code;
};

pc_file_error OPEN_ERROR =	{ 1 };
pc_file_error READ_ERROR =	{ 2 };
pc_file_error CLOSE_ERROR =	{ 3 };
pc_file_error WRITE_ERROR = { 4 };
*/

long	BLOCK_BITMASK[] =
{
	0x100,0x200,0x400,0x800,0x1000,0x2000,0x4000,0x8000,
	0x10000,0x20000,0x40000,0x80000,0x100000,0x200000,0x400000,0x800000,
	0x1000000,0x2000000,0x4000000,0x8000000,
	0x10000000,0x20000000,0x40000000,0x80000000
};

c1541_error OK =							{	"00, OK. CODED BAD." ,0,0 };
c1541_error PROGRAM =					{	"49,PROGRAM ERROR" ,0,0 };
c1541_error ILLEGAL_DISK_RANGE =		{	"67,ILLEGAL T OR S" ,0,0 };
c1541_error ILLEGAL_TRACK_SECTOR =	{	"66,ILLEGAL TRACK AND SECTOR" ,0,0 };
c1541_error DISK_FULL =					{	"72,DISK FULL" ,0,0 };
c1541_error LOOPING_BLOCK_CHAINING = { "52,LOOPING BLOCK CHAINING" ,0,0 };
c1541_error FILE_EXISTS =				{	"63,FILE EXISTS" ,0,0 };
c1541_error FILE_TYPE_MISMATCH =		{	"64,FILE TYPE MISMATCH" ,0,0 };
c1541_error FILE_NOT_FOUND =		{	"62,FILE NOT FOUND" ,0,0 };
c1541_error WRITE_FILE_OPEN =		{	"60,WRITE FILE OPEN" ,0,0 };
c1541_error SYNTAX_ERROR =			{	"30,SYNTAX ERROR" ,0,0 };
c1541_error NO_CHANNEL_AVAILABLE =	 {	"70,NO CHANNEL" ,0,0 };
c1541_error DRIVE_NOT_READY =			{	"74,DRIVE NOT READY" ,0,0 };
c1541_error DISKIMAGE_READ_FAILURE =	 {	"74,DISKIMAGE READ FAILURE" ,0,0 };
c1541_error NO_BLOCK =					{	"65,NO BLOCK" ,0,0 };


Label c1541_Filename_LabelList[] =
{
	{ "S"			,FILE_TYPE_SEQ, 0 },
	{ "P"			,FILE_TYPE_PRG, 0 },
	{ "U"			,FILE_TYPE_USR, 0 },
	{ "R"			,FILE_ACCESS_READ, 0 },
	{ "W"			,FILE_ACCESS_WRITE, 0 },
	{ "A"			,FILE_ACCESS_APPEND, 0 },
	{ "\0"		,-1, 0 }
};

char FileTypeChar[8][4] =
{
	"DEL", "SEQ", "PRG", "USR", "REL",
	"???", "???", "???"
};

void Block::SetDiskImage(byte* _diskimage)
{
	diskimage = _diskimage;
}

long Block::AddNewBlock(long pos)
{
	long new_pos
		= BAM(diskimage+LOGICAL_BAM_POSITION).SearchAndAllocFreeBlock(pos);
	WriteNextBlock(new_pos);
	position = new_pos;
	return new_pos;
}

long Block::AddNewBlock()
{
	return AddNewBlock(position);
}

long Block::NextTrack()
{
	return (long) diskimage[position];
}

long Block::NextSector()
{
	return (long) diskimage[position+1];
}

void Block::SetNextTrack(long _track)
{
	 diskimage[position] = (char) _track;
}

void Block::SetNextSector(long _sector)
{
	diskimage[position+1] = (char) _sector;
}

long Block::GetNextBlock()
{
	if (! NextTrack()) return -1;
	GetLogical( NextTrack(),NextSector() );
	return position;
}

long Block::GetBlockSize()
{
	if (! NextTrack()) return NextSector()+1;
	return BLOCK_SIZE;
}

void Block::WriteNextBlock(long pos)
{
	Block block(pos);
	block.GetPhysical();

	SetNextTrack(block.track);
	SetNextSector(block.sector);
}

void Block::WriteEndBlock(long size)
{
	SetNextTrack(0);
	SetNextSector(size-1);
}

void Block::ClearBlock()
{
	long c = BLOCK_SIZE;
	while (c-->0) diskimage[position+c] = 0;
}

void Block::GetPhysical()
{
	if (position & 0x00ff) throw &PROGRAM;
	long 	block = position >> 8;

	if (block < 0 || block >= BLOCKS_OF_A_DISK)
	{
		throw &ILLEGAL_DISK_RANGE;
	}

	int c = -1;
	while (++c < TRACK_AREAS)
	{
		if (block < TRACK_AREA_Blocks[c])
		{
			track = block / TRACK_AREA_SectorsPerTrack[c];
			sector = block % TRACK_AREA_SectorsPerTrack[c];
			track += TRACK_AREA_FirstTrack[c];
			break;
		}
		block -= TRACK_AREA_Blocks[c];
	}
}

void Block::GetLogical(long _track, long _sect)
{
	track = _track;
	sector = _sect;

	if ( _sect < 0 ) throw &ILLEGAL_TRACK_SECTOR;
	if ( _track < FIRST_TRACK || _track >= END_TRACK ) throw &ILLEGAL_TRACK_SECTOR;

	int c = -1;
	while (++c < TRACK_AREAS)
	{
		_track = track - TRACK_AREA_FirstTrack[c];

		if( _track < TRACK_AREA_Tracks[c] )
			if ( _sect < TRACK_AREA_SectorsPerTrack[c] )
			{
				position = TRACK_AREA_LogicalStartPosition[c]
					+  (( TRACK_AREA_SectorsPerTrack[c] * _track + _sect) << 8);
				break;
			}
			else
				throw &ILLEGAL_TRACK_SECTOR;
	}
}


BOOL	BAM::AllocateBlock(long pos)
{
	Block 	block(pos);
	block.GetPhysical();

	long* Alloc = (long*) BAM_pointer + block.track;

	if (! (*Alloc & BLOCK_BITMASK[block.sector]) ) return FALSE;

	*Alloc &= ~ BLOCK_BITMASK[block.sector];
	(*(byte*) Alloc)--;
	return TRUE;
}

BOOL	BAM::DeAllocBlock(long pos)
{
	Block		block(pos);
	block.GetPhysical();

	long* Alloc = (long*) BAM_pointer + block.track;

	if ( *Alloc & BLOCK_BITMASK[block.sector] ) return FALSE;

	*Alloc |= BLOCK_BITMASK[block.sector];
	(*(byte*) Alloc)++;
	return TRUE;
}

long	BAM::SearchAndAllocFreeBlock(long pos)
{
	long startpos = pos;

	while (1)
	{
		pos += BLOCK_SIZE;
		if (pos == DISK_SIZE) pos = 0;
		if (AllocateBlock(pos)) break;

		if (pos == startpos) throw &DISK_FULL;
	}
	return pos;
}

long BAM::GetFreeBlocks()
{
	long* bam_pointer = (long*) BAM_pointer;
	long start_track = TRACK_AREA_FirstTrack[0];
	long last_track = TRACK_AREA_FirstTrack[TRACK_AREAS];
	long blocks = 0;

	while (--last_track >= start_track)
		blocks += bam_pointer[last_track] & 0xff;

	return blocks;
}



DiskIO::DiskIO(long pos ,byte* _diskimage) : Block(pos,_diskimage)
{
	subpos = BLOCK_HEADER_SIZE;
	block_size = GetBlockSize();
}

void DiskIO::SetDiskImage(byte* _diskimage)
{
	Block::SetDiskImage(_diskimage);
}

void DiskIO::SetPosition(long pos)
{
	position = pos;
	subpos = BLOCK_HEADER_SIZE;
	block_size = GetBlockSize();
}

void DiskIO::WriteFileEnd()
{
	WriteEndBlock(subpos);
}

long DiskIO::Read()
{
	if (subpos >= block_size)
	{
		if (GetNextBlock() < 0) return -1;
		block_size = GetBlockSize();
		if (block_size <= BLOCK_HEADER_SIZE) return -1;
		subpos = BLOCK_HEADER_SIZE;
	}
	return diskimage[position+subpos++];
}

long DiskIO::Read_with_EOF()
{
	long x = Read();

	long end_flag = 0;
	if (subpos >= block_size)
		if (! NextTrack()) end_flag = EOF_FLAG;
	
	return x | end_flag;
}

/*
long DiskIO::Read_with_EOF()
{
	long last_date = read_date_EOF;
	read_date_EOF = Read();

	if (read_date_EOF < 0 ) return last_date | EOF_FLAG;
	return last_date;
}*/


void DiskIO::Write(long ch)
{
	if (subpos >= BLOCK_SIZE)
	{
		AddNewBlock();
		subpos = BLOCK_HEADER_SIZE;
	}
	diskimage[position+subpos++] = (byte) ch;
}

void DiskIO::SeekEnd()
{
	long c = BLOCKS_OF_A_DISK;
	while (c-->0)
	{
		if (GetNextBlock() < 0)
		{
			subpos = GetBlockSize();
			return;
		}
	}
	throw &LOOPING_BLOCK_CHAINING;
}



Directory::Directory(byte* _diskimage) : Block(LOGICAL_BAM_POSITION, _diskimage)
{
	localpointer = BLOCK_SIZE;
}

void Directory::Reset()
{
	position = LOGICAL_BAM_POSITION;
	localpointer = BLOCK_SIZE;
}

void Directory::SetDiskImage(byte* _diskimage)
{
	Block::SetDiskImage(_diskimage);
}

void Directory::DeleteFile()
{
	SetFileType(FILE_TYPE_DEL);

	Block block(GetFilePosition(),diskimage);
	BAM bam(diskimage+LOGICAL_BAM_POSITION);

	while(1)
	{
		bam.DeAllocBlock(block.position);
		if (block.GetNextBlock()<0) break;
	}
}

void Directory::CloseFile()
{
	SetFileType(GetFileType() | FILETYPE_CLOSED_FLAG);

	long block_number = 1;
	Block block(GetFilePosition(),diskimage);
	while(1)
	{
		if (block.GetNextBlock()<0) break;
		block_number++;
	}
	SetBlockNumber(block_number);
}

void Directory::EnterFilePosition()
{
	BAM bam(diskimage+LOGICAL_BAM_POSITION);

	SetFilePosition(
		bam.SearchAndAllocFreeBlock(LOGICAL_DIRECTORY_END_POSITION-BLOCK_SIZE)
						 );
}

BOOL Directory::TestValidFileEntry()
{
	return (BOOL) GetFileType();
}

BOOL Directory::SearchFileEntry(char* filename)
{
	while (1)
	{
		if (GetNextFileEntry() < 0) return FALSE;
		if (TestValidFileEntry())
			if (CompareFileName(filename)) return TRUE;
	}
}

BOOL Directory::CompareFileName(char* filename)
{
	char* dir_file = GetFileName();

	long c = -1;
	while (++c < FILE_ENTRY_FILENAME_SIZE)
	{
		if (filename[c] == '*') break;

		if ((unsigned char) dir_file[c] == FILENAME_FILL_BYTE)
			if (filename[c] == 0) break;
			else return FALSE;

		if (filename[c] != '?')
			if (dir_file[c] != filename[c]) return FALSE;
	}
	return TRUE;
}

long Directory::CopyFileName(char* name)
{
	char* dir_file = GetFileName();

	long c = -1;
	while (++c < FILE_ENTRY_FILENAME_SIZE)
	{
		if ((unsigned char) dir_file[c] == FILENAME_FILL_BYTE)
			break;
		name[c] = dir_file[c];
	}
	name[c] = 0;
	return c;
}

char* Directory::GetFileName()
{
	return
	( (FILE_ENTRY*) &(diskimage[position+localpointer]) )->filename;
}

void Directory::SetFileName(char* filename)
{
	char* dir_file = GetFileName();

	BOOL flag = FALSE;
	long c=-1;
	while (++c < FILE_ENTRY_FILENAME_SIZE)
	{
		char ch = filename[c];
		if (ch == 0) flag = TRUE;
		if (flag) ch = (char) FILENAME_FILL_BYTE;
		dir_file[c] = ch;
	}
}

long Directory::GetFileType()
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	return file->filetype;
}

void Directory::SetFileType(long type)
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	file->filetype = (byte) type;
}

long Directory::GetFilePosition()
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	Block block(file->track,file->sector);
	return block.position;
}

void Directory::SetFilePosition(long pos)
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	Block block(pos);
	block.GetPhysical();
	file->track = (byte) block.track;
	file->sector = (byte) block.sector;
}

long Directory::GetBlockNumber()
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	return file->blocknumber;
}

void Directory::SetBlockNumber(long blocks)
{
	FILE_ENTRY* file = (FILE_ENTRY*) &(diskimage[position+localpointer]);
	file->blocknumber = (word) blocks;
}

long Directory::GetNextFileEntry()
{
	localpointer += sizeof(FILE_ENTRY);
	if (localpointer >= BLOCK_SIZE)
		{
			localpointer = 0;
			return GetNextBlock();
		}
	return position+localpointer;
}

void Directory::SearchFileEntry()
{
	while (1)
	{
		if (GetNextFileEntry() <0)
		{
			AddNewBlock(LOGICAL_BAM_POSITION);
			ClearBlock();
			WriteEndBlock(0x100);
			break;
		}

		if (! TestValidFileEntry()) break;
	}
}


byte* c1541::BoostWriteBus(long& length)
{
	byte* buffer = new byte[DISK_SIZE];

	int c = -1, d;
	while (++c < DISK_SIZE)
	{
		d = WriteBus();
		buffer[c] = (byte) d;
		if (d & EOF_FLAG) break;
	}
	length = c+1;
	return buffer;
}

void c1541::BoostReadBus(byte* buffer,long length)
{
	DiskIO* diskio = & secundar->disk_io;

	long c = -1;
	while (++c < length)
		WriteDiskIO(buffer[c]);
		//diskio->Write(buffer[c]);
}


void c1541::Reset(byte* _diskimage)
{
	diskimage = _diskimage;

	long c = 16;
	while (c-->0)
	{
		secundar_table[c].valid = FALSE;
		secundar_table[c].directory.SetDiskImage(_diskimage);
		secundar_table[c].disk_io.SetDiskImage(_diskimage);
	}

	c = C1541_RAM_START_BUFFER - 1;
	while (++c <= C1541_RAM_LAST_BUFFER) buffer_alloc_table[c] = FALSE;

	work_buffer = ram;
	diskimage_changed = FALSE;
	ram_changed = FALSE;
	device_flag = DEVICE_FLAG_NONE;
	bus_status = BUS_IGNORE;
	error = &OK;
}

void c1541::Exception(c1541_error* code)
{
	error = code;
	secundar->valid = FALSE;
	bus_status = BUS_IGNORE;
}

void c1541::ListenTalk(long _device)
{
	term << "\n listentalk = " << _device;
	device_flag = _device & 0xf0;
	bus_status = BUS_IGNORE;
}

void c1541::UnTalk()
{
	term << "\n untalk";
	bus_status = BUS_IGNORE;
}

void c1541::UnListen()
{
	term << "\n unlisten";
	if (bus_status == BUS_TO_WORK_BUFFER)
	{
		work_buffer[work_buffer_pos] = 0;

		if (secundar_instruction_channel)
			ExecuteInstruction();
		else
		{
			secundar->valid = TRUE;
			error = &OK;

			AnalyseFileName();
			if (secundar->directory_mode) OpenDirectory();
			else
				if (secundar->buffer_mode) OpenBuffer();
				else
				{
					OpenFile();
				//	if (secundar->disk_io_read)
				//		ReadDiskIO();
				}
		}
	}
	bus_status = BUS_IGNORE;
}

void c1541::SetSecundarAddr(long sec_addr)
{
	term << "\nsecundar = " << sec_addr;
	device_flag = DEVICE_FLAG_NONE;

	secundar_flag = sec_addr & 0xf0;
	secundar_addr = sec_addr & 0x0f;
	secundar = &(secundar_table[secundar_addr]);
	if (secundar_addr == 15) secundar_instruction_channel = TRUE;
	else	secundar_instruction_channel = FALSE;
}

void c1541::SecundarAddrListen(long sec_addr)
{
	term << "\nsecundar listen";
	if (device_flag != DEVICE_FLAG_LISTEN) return;
	SetSecundarAddr(sec_addr);

	switch(secundar_flag)
	{
		case SECUNDAR_FLAG_OPEN_FILE:

			term << "\nopen file";
			if (secundar_instruction_channel)
				break;

			if (secundar->valid && secundar->buffer_mode)
				buffer_alloc_table[secundar->buffer_number] = FALSE;

			bus_status = BUS_TO_WORK_BUFFER;
			work_buffer_pos = 0;

			secundar->valid = FALSE;
			break;

		case SECUNDAR_FLAG_CLOSE_FILE:

			if (secundar_instruction_channel)
				break;

			if (secundar->valid)
				if (secundar->buffer_mode)
					buffer_alloc_table[secundar->buffer_number] = FALSE;
				else
					CloseFile();

			secundar->valid = FALSE;
			break;

		case SECUNDAR_FLAG_NORMAL:

			if (secundar_instruction_channel)
			{
				bus_status = BUS_TO_WORK_BUFFER;
				work_buffer_pos = 0;
			}
			else
				if (secundar->valid)
					if (secundar->buffer_mode)
						bus_status = BUS_TO_BUFFER;
					else
						if (! secundar->disk_io_read)
							bus_status = BUS_TO_DISK_IO;
						else
							bus_status = BUS_IGNORE;
			break;

		default:

			bus_status = BUS_IGNORE;
			break;
	}
}

void c1541::SecundarAddrTalk(long sec_addr)
{
	term << "\nsecundar talk";
	if (device_flag != DEVICE_FLAG_TALK) return;
	SetSecundarAddr(sec_addr);

	if (secundar_flag != SECUNDAR_FLAG_NORMAL) return;

	if (secundar_instruction_channel)
	{
		Get_C1541_Error();
		bus_status = WORK_BUFFER_TO_BUS;
		work_buffer_pos = 0;
		return;
	}

	if (secundar->valid)
		if (secundar->buffer_mode)
			bus_status = BUFFER_TO_BUS;
		else
			if (secundar->directory_mode)
				bus_status = DIRECTORY_TO_BUS;
			else
				if (secundar->disk_io_read)
					bus_status = DISK_IO_TO_BUS;
				else
					bus_status = BUS_IGNORE;
}

void c1541::ReadBus(long date)
{
	switch (bus_status)
	{
		case BUS_TO_DISK_IO:

			WriteDiskIO(date);
			break;
		
		case BUS_TO_WORK_BUFFER:

			if (work_buffer_pos >= WORK_BUFFER_SIZE) break;
			work_buffer[work_buffer_pos++] = (byte) date;
			
			if (work_buffer_pos == 3)
			{
				work_buffer[work_buffer_pos] =0;
				str com = (char*) work_buffer;
				if (com == "M-E") InstructionMemoryExecute();
			}
				term << "\n BUS " <<(char) date << "  " << date;
			break;

		case BUS_TO_BUFFER:

			ram[secundar->buffer_number*BLOCK_SIZE + secundar->buffer_pointer]
				= (byte) date;
			if (++secundar->buffer_pointer >= BLOCK_SIZE)
				secundar->buffer_pointer = 0;
			break;
	}
}

void c1541::WriteDiskIO(long date)
{
	secundar->disk_io.Write(date);
}

long c1541::WriteBus()
{
	long date = 0x80;

	switch (bus_status)
	{	
		case DISK_IO_TO_BUS:

			date = ReadDiskIO();
			break;

		case WORK_BUFFER_TO_BUS:

			if (work_buffer_pos >= WORK_BUFFER_SIZE) break;
			date = (byte) work_buffer[work_buffer_pos++];
			if (date == 13)
			{
				work_buffer_pos = 0;
				date |= EOF_FLAG;
			}
			break;

		case BUFFER_TO_BUS:

			date =
			ram[secundar->buffer_number*BLOCK_SIZE + secundar->buffer_pointer];

			if (++secundar->buffer_pointer >= BLOCK_SIZE)
				secundar->buffer_pointer = 0;
			break;

		case DIRECTORY_TO_BUS:

			if (dir_buffer_pos == dir_line_size)
				DirectoryMode_NextEntry();

			if (! directory_valid)
			{
				date = 0 | EOF_FLAG;
				break;
			}

			date = (byte) dir_buffer[dir_buffer_pos++];
			break;
	}
	return date;
}

long c1541::ReadDiskIO()
{
	return secundar->disk_io.Read_with_EOF();
}

void c1541::DirectoryMode_NextEntry()
{
	if (directory_end) { directory_valid = FALSE; return; }

	long c = DIRECTORY_BASIC_LINE_SIZE+5;
	while(c-->0) dir_buffer[c] = ' ';

	dir_line_size = DIRECTORY_BASIC_LINE_SIZE;
	dir_buffer_pos = 0;

	if (directory_start)
	{
		*(word*) &dir_buffer[dir_buffer_pos] = BASIC_START;
		dir_buffer_pos += sizeof(word);
		dir_line_size += sizeof(word);
	}

	directory_basic_pointer += DIRECTORY_BASIC_LINE_SIZE;
	*(word*) &dir_buffer[dir_buffer_pos] = (word) directory_basic_pointer;
	dir_buffer_pos += sizeof(word);

	DirectoryMode_WriteEntry();

	directory_start = FALSE;
	dir_buffer_pos = 0;
	
	if (directory_end)
	{
		dir_buffer[dir_line_size++] = 0;
		dir_buffer[dir_line_size++] = 0;
	}
	else
		dir_buffer[dir_line_size-1] = 0;

}

void c1541::DirectoryMode_WriteEntry()
{
	Directory* dir = &secundar->directory;

	while (1)
	{
		if (dir->GetNextFileEntry() < 0)
		{
			long number = BAM(diskimage+LOGICAL_BAM_POSITION).GetFreeBlocks();
			*(word*) &dir_buffer[dir_buffer_pos] = (word) number;
			dir_buffer_pos += 2;

			char* xx = &dir_buffer[dir_buffer_pos];
			sprintf(xx,"BLOCKS FREE. CODED BAD.");
			xx[strlen(xx)] = ' ';
			directory_end = TRUE;

			return;
		}

		if (dir->TestValidFileEntry())
			if (dir->CompareFileName(directory_filename)) break;
	}

	DirectoryMode_WriteBasicLineNumber((word)dir->GetBlockNumber());


	long ft = dir->GetFileType();
	if (!(ft & FILETYPE_CLOSED_FLAG))
		dir_buffer[dir_buffer_pos + DIR_EINRUCKEN_FILETYPE-1] = '*';
	if (ft & FILETYPE_WRITEPROTECTED_FLAG)
		dir_buffer[dir_buffer_pos + DIR_EINRUCKEN_FILETYPE+3] = '<';

	ft = ft & FILE_TYPE_BITMASK;
	long c = 3;
	while (c-->0) dir_buffer[dir_buffer_pos+DIR_EINRUCKEN_FILETYPE+c] = FileTypeChar[ft][c];


	dir_buffer[dir_buffer_pos++] = '"';
	dir_buffer_pos += dir->CopyFileName(dir_buffer+dir_buffer_pos);
	dir_buffer[dir_buffer_pos++] = '"';
}

void c1541::DirectoryMode_WriteBasicLineNumber(word X)
{
	*(word*) &dir_buffer[dir_buffer_pos] = X;

	dir_buffer_pos += 1;

	if (X < 10000) dir_buffer_pos++;
	if (X < 1000) dir_buffer_pos++;
	if (X < 100) dir_buffer_pos++;
	if (X < 10) dir_buffer_pos++;
}


void c1541::OpenDirectory()
{
	term << "\n hallo open dir";
	if (secundar_addr != 0)
	{
		secundar->valid = FALSE;
		return;
	}

	secundar->directory.Reset();
	secundar->disk_io_read = TRUE;
   if (*filename == 0) { *filename = '*'; filename[1] = 0; }
	directory_filename = filename;
	directory_start = TRUE;
	directory_basic_pointer = BASIC_START;
	directory_end = FALSE;
	directory_valid = TRUE;
	dir_buffer_pos = 0;
	dir_line_size = 0;
}


void c1541::OpenBuffer()
{
	TextHandling txt = TextHandling(filename,0,0);
	long number;

	if (txt.GetDecNumber())
	{
		number = txt.number;

		if (number < C1541_RAM_START_BUFFER || number > C1541_RAM_LAST_BUFFER)
			throw &NO_CHANNEL_AVAILABLE;

		if (buffer_alloc_table[number]) throw &NO_CHANNEL_AVAILABLE;
	}
	else
	{
		number = C1541_RAM_START_BUFFER;
		while (1)
		{
			if (number > C1541_RAM_LAST_BUFFER)
				throw &NO_CHANNEL_AVAILABLE;
			if (! buffer_alloc_table[number]) break;
			number++;
		}
	}

	buffer_alloc_table[number] = TRUE;
	secundar->buffer_number = number;
	secundar->buffer_pointer = 0;
}

void c1541::OpenFile()
{
	Directory* dir = & secundar->directory;
	dir->Reset();

	DiskIO* disk_io = & secundar->disk_io;

	if (dir->SearchFileEntry(filename))
	{
		if (file_access == FILE_ACCESS_WRITE)
			if (overwrite_file)
				dir->DeleteFile();
			else
				throw &FILE_EXISTS;
		else
			if (file_type != FILE_TYPE_ANY)
				if ((dir->GetFileType() & FILE_TYPE_BITMASK) != file_type)
					throw &FILE_TYPE_MISMATCH;
	}
	else
		if (file_access != FILE_ACCESS_WRITE)
		{
			term << filename;

			throw &FILE_NOT_FOUND;
		}

	secundar->disk_io_read = TRUE;

	if (file_access == FILE_ACCESS_WRITE)
	{
		dir->Reset();
		dir->SearchFileEntry();
		dir->SetFileName(filename);
		dir->SetFileType(file_type);
		dir->EnterFilePosition();

		diskimage_changed = TRUE;
		secundar->disk_io_read = FALSE;
	}

	disk_io->SetPosition(dir->GetFilePosition());

	if (file_access == FILE_ACCESS_APPEND)
	{
		disk_io->SeekEnd();
		diskimage_changed = TRUE;
		secundar->disk_io_read = FALSE;
	}
}

void c1541::CloseFile()
{
	if (! secundar->disk_io_read)
	{
		secundar->disk_io.WriteFileEnd();
		secundar->directory.CloseFile();
	}
}


void c1541::AnalyseFileName()
{
	TextHandling filnam((char*) work_buffer,0,c1541_Filename_LabelList);
		term << work_buffer;

	file_access = FILE_ACCESS_READ;
	file_type = FILE_TYPE_PRG;
	if (secundar_addr < 2) file_type = FILE_TYPE_PRG;

	while (1)
	{
		if (! filnam.SearchChar(',')) break;

		long label = filnam.GetLabel();
		if (label < 0) break;

		if (label < FILE_ACCESS_READ) file_type = label;
		else file_access = label;
	}
	if (secundar_addr == 0) file_access = FILE_ACCESS_READ;
	if (secundar_addr == 1) file_access = FILE_ACCESS_WRITE;



	overwrite_file = FALSE;
	secundar->directory_mode = FALSE;
	secundar->buffer_mode = FALSE;

	filnam.position = 0;
	if (filnam.SearchChar(','))
	{
		filnam.text[filnam.position-1] = 0;
		filnam.position = 0;
	}

	if (filnam.GetChar('@')) overwrite_file = TRUE;
	else
		if (filnam.GetChar('$')) secundar->directory_mode = TRUE;
		else
			if (filnam.GetChar('#')) secundar->buffer_mode = TRUE;

	filnam.SearchChar(':');
	filnam.GetText();
	filename = &(filnam.text[filnam.position-filnam.length]);

	term << "\n FILEACCES =" << (long) file_access;
	term << "\n FILETYPE =" << (long) file_type;
}


void c1541::InstructionBlockTransfer()
{
	ram_changed = TRUE;

	term << "\n ES IST=" << order.text + order.position;
	byte* buffer = &ram[secundar_table[InstructionReadChannelNumber()].buffer_number * BLOCK_SIZE];
	InstructionIgnoreNumber();
	long disk_pos = InstructionReadTrackSector();

	long c = BLOCK_SIZE;
	if (order.label->id)
	{  c = BLOCK_SIZE-1;                                    //strange U2
		while (c-->0) diskimage[disk_pos+c+1] = buffer[c];
		diskimage[disk_pos] = buffer[BLOCK_SIZE-1];          //Attenion: Check the exact U1/U2/B-R/B-W functionality
		diskimage_changed = TRUE;
	}
	else
		while (c-->0) buffer[c] = diskimage[disk_pos+c];
}

void c1541::InstructionBufferPointer()
{
	long channel = InstructionReadChannelNumber();
	if (! order.SearchDecNumber()) throw &SYNTAX_ERROR;

	secundar_table[channel].buffer_pointer = order.number % BLOCK_SIZE;
}

void c1541::InstructionMemoryWrite()
{
	ram_changed = TRUE;

	long ram_addr = order.GetChar() + order.GetChar()*0x100;
	long length = order.GetChar();

	while (length-->0)
	{
		if (ram_addr >= 0 && ram_addr < C1541_RAM_SIZE)
			ram[ram_addr] = order.GetChar();
		
		ram_addr++;
	}
}

void c1541::InstructionMemoryExecute()
{
	return;  // tja.....

/*		BRAUCHE NICHT

	term << "\n *** M-E Instruction ***";

	AfxMessageBox("HARD ERROR:\n\nC1541 instruction ''M-E'' (memory execution) not supported!",MB_OK);

	return;  // tja.....


	CFileFind find;
	if (! find.FindFile((str(M_E_INSTRUCTION_PATH)+str("*")).ch())) {term << "\n  FEHLER! ";return;}

//		CString aa = find.GetFileName();
//			term << " \n HAHA: " << str(aa.GetBuffer(aa.GetLength())).ch();
		
	while (1)
	{
		if(! find.FindNextFile()) break;
		
		if (find.IsDirectory())
		{
			CString fn = find.GetFileName();
			str fn_2 = str(fn.GetBuffer(fn.GetLength()));
			
			if (!(fn_2 == "." || fn_2 == ".."))
			{
				while (1)
				{
				str entry = str(M_E_INSTRUCTION_PATH)+fn_2+str("\\");
				str entry_2 = entry;
				str entry_3 = entry;
				term << "\n Found M-E Entry: " << entry.ch();
				
				int size = C1541_RAM_SIZE, offset;
				unsigned char* addr = Load_C64_File((entry + str(M_E_INSTRUCTION_FLOPPY_FILENAME)).ch(),size,offset);
				if (!addr) break;
				while (size-->0)
					if (ram[size+offset] == addr[size+2]) {}
					else
						{ delete addr; break; }
				delete addr;
								
				size = 0x10000;
				addr = Load_C64_File((entry_2 + str(M_E_INSTRUCTION_C64_FILENAME)).ch(),size,offset);
				if (!addr) break;
				unsigned char* addr_2 = Read_C64(offset,size);
			//	try
			//	{
			//		short start = 0x1000;
			//		CFile k("C64Read.prg",CFile::modeCreate|CFile::modeWrite);
			//		k.Write(&start,2);
			//		k.Write(addr_2,size);
			//		k.Close();
			//	}
			//	catch(CFileException*) {}

				while (size-->0)
					if (addr_2[size] == addr[size+2]) {}
					else
						{ delete addr; delete addr_2; break; }
				delete addr; delete addr_2;

				size = 0x10000;
				addr = Load_C64_File((entry_3 + str(M_E_INSTRUCTION_C64_NEW_FILENAME)).ch(),size,offset);
				if (!addr) break;
				Write_C64(addr+2,offset,size);
				
				term << "\n SPEEDER " << fn_2.ch() << " DETECTED!";
				return;
				}
			}
		}
	}*/
}

unsigned char* c1541::Load_C64_File(char* filename,int& size, int& offset)
{
	return 0;

	/*		BRAUCHE NICHT

	term << "\n   Lade C64 File: " << filename;

	unsigned char* buffer;
	try
	{
		CFile file(filename,CFile::modeRead);

		buffer = new unsigned char[size];
		size = file.Read(buffer,size);
		file.Close();

		offset = *buffer + *(buffer+1) * 0x100;
		size -= 2;
		return buffer;
	}
	catch (CFileException*)
	{
		return 0;
	}
	*/
}
	
	



void c1541::InstructionIgnoreNumber()
{
	if (! order.SearchDecNumber()) throw &SYNTAX_ERROR;
}

long c1541::InstructionReadChannelNumber()
{
	long channel;

	if (order.SearchDecNumber()) channel = order.number;
		else throw &SYNTAX_ERROR;

	if (channel < 0 || channel > 14) throw &NO_CHANNEL_AVAILABLE;
	if ( !secundar_table[channel].valid || !secundar_table[channel].buffer_mode)
		throw &NO_CHANNEL_AVAILABLE;

	return channel;
}

long c1541::InstructionReadTrackSector()
{
	long track, sector;

	if (order.SearchDecNumber()) track = order.number;
		else throw &SYNTAX_ERROR;

	if (order.SearchDecNumber()) sector = order.number;
		else throw &SYNTAX_ERROR;

	Block block(track, sector);
	return block.position;
}

Label c1541_InstructionChannel_LabelList[] =
{
	{ "BLOCK-READ"		,0	,&c1541::InstructionBlockTransfer },
	{ "B-R"				,0	,&c1541::InstructionBlockTransfer },
	{ "U1"				,0	,&c1541::InstructionBlockTransfer },
	{ "UA"				,0	,&c1541::InstructionBlockTransfer },

	{ "BLOCK-WRITE"	,1	,&c1541::InstructionBlockTransfer },
	{ "B-W"				,1	,&c1541::InstructionBlockTransfer },
	{ "U2"				,1	,&c1541::InstructionBlockTransfer },
	{ "UB"				,1	,&c1541::InstructionBlockTransfer },

	{ "BLOCK-POINTER"	,0	,&c1541::InstructionBufferPointer },
	{ "B-P"				,0	,&c1541::InstructionBufferPointer },

	{ "M-W"				,2 ,&c1541::InstructionMemoryWrite },

	{ "\n"				,-1, 0	}
};

void c1541::ExecuteInstruction()
{
	order.SetTextHandling((char*)work_buffer,0,c1541_InstructionChannel_LabelList);

	if (order.GetLabel() < 0){
		term <<"\n UNBEKANNTER BEFEHL!";
//kalb:
//		goto kalb;
		throw &SYNTAX_ERROR;
	}
	(this->*(order.label->function))();
}


void c1541::Get_C1541_Error()
{
	sprintf((char*)work_buffer,error->error_text);
	sprintf((char*)work_buffer + strlen((char*)work_buffer)
		 , ",%d,%d", error->track, error->sector);
	*(long*)&work_buffer[strlen((char*)work_buffer)] = 13;

	error = &OK;
}




