
//#include "stdafx.h"
#include "handling.h"


TextHandling::TextHandling(char* _text,long pos,Label* _list)
{
	text = _text;
	position = pos;
	list = _list;
}

void TextHandling::SetTextHandling(char* _text,long pos,Label* _list)
{
	text = _text;
	position = pos;
	list = _list;
}


void TextHandling::GetText()
{
	length = 0;

	while (1)
	{
		char character = text[position+length];

		if (character >= 32 && character != ',')
			length++;
		else break;
	}
	position += length;
}

BOOL TextHandling::IgnoreExtraCharacters()
{
	length = 0;

	while (1)
	{
		char character = text[position+length];

		if (character == 0 || character == 13)
		{
			position += length;
			return FALSE;
		}
		if (character == ' ' || character == 0x0c || character == ':')
			length++;
		else break;
	}
	position += length;
	return TRUE;
}

long TextHandling::GetLabel()
{
	length = 0;
	long list_entry = 0;

	while(1)
	{
		if (list[list_entry].id < 0) break;

		char label_char = list[list_entry].name[length];

		if (label_char == 0) break;
		if (label_char == text[position+length]) length++;
			else
			{
				length = 0;
				list_entry++;
			}
	}
	position += length;
	label = &list[list_entry];
	return label->id;
}

BOOL TextHandling::SearchDecNumber()
{
	long subpos = 0;
	while (1)
	{
		char ch = text[position+subpos];
		if (ch == 0) return FALSE;
		if (ch >= '0' && ch <= '9') break;
		subpos++;
	}
	position += subpos;
	return GetDecNumber();
}

BOOL TextHandling::GetDecNumber()
{
	number = 0;
	length = 0;

	while(length < 8)
	{
		char ch = text[position+length];
		if (ch >= '0' && ch <= '9') number = number*10+(long)(ch-'0');
		else break;
		length++;
	}
	position += length;
	return (BOOL) length;
}

unsigned char TextHandling::GetChar()
{
	return text[position++];
}

BOOL TextHandling::GetChar(char ch)
{
	if (text[position] != ch) return FALSE;
	position++;
	return TRUE;
}

BOOL TextHandling::SearchChar(char ch)
{
	long subpos = 0;

	while (1)
	{
		if (text[position+subpos] == 0) return FALSE;
		if (text[position+subpos] == ch) break;
		subpos++;
	}
	position += subpos+1;
	return TRUE;
}



