
//#include "stdafx.h"
#include "str.h"


int str::MarkStart()
{
	if (mark_curr > mark_last) return mark_last;
	else return mark_curr;
}

int str::MarkLen()
{
	int x = mark_curr - mark_last;
	if (x<0) x *= -1;
	return x;
}

str::str()
{
	str_mem_allocated = FALSE;
	string = 0;
	found = TRUE;
	negative_flag = FALSE;
	do_not_deallocate = FALSE;
}

str::str(str& in)
{
	str_mem_allocated = FALSE;
	do_not_deallocate = FALSE;
	operator=(in);
}

str::str(char* in)
{
	str_mem_allocated = FALSE;
	do_not_deallocate = FALSE;
	operator=(in);
}

str::~str()
{
	if (str_mem_allocated && !do_not_deallocate)
		delete string;
}

void str::operator=(str& in)
{
	if (str_mem_allocated) delete string;
	
	str_mem_allocated = FALSE;
	string = in.string + in.MarkStart();
	string_len = in.MarkLen();

	mark_curr = 0;
	mark_last = string_len;
	found = TRUE;
	negative_flag = FALSE;

	AllocateString();
}

void str::operator=(char* in)
{
	if (str_mem_allocated) delete string;

	str_mem_allocated = FALSE;
	string = in;
	string_len = -1;
	while (in[++string_len]) {}

	mark_curr = 0;
	mark_last = string_len;
	found = TRUE;
	negative_flag = FALSE;

//	AllocateString();
}

str& str::operator!()
{
	negative_flag = TRUE;
	return *this;
}

char* str::ch()
{
	negative_flag = FALSE;

	if (str_mem_allocated && MarkStart() == 0 && MarkLen() == string_len)
		return string;
	
	return AllocateString();
}

void str::DoNotDeallocate()
{
	do_not_deallocate = TRUE;
}

char* str::Addr()
{
	return string;
}

char* str::AllocateString()
{
	int c = MarkLen();
	int start = MarkStart();
	
	char* old_str = string;
	string_len = c;
	string = new char[c+1];
	string[c] = 0;
	while (c-->0) string[c] = old_str[start+c];

	if (str_mem_allocated) delete old_str;

	mark_curr = 0;
	mark_last = string_len;
	str_mem_allocated = TRUE;
	negative_flag = FALSE;
	
	return string;
}


str& str::operator<<(int s)
{
	mark_curr -= s;
	if (mark_curr < 0) mark_curr = 0;
	mark_last = mark_curr;
	negative_flag = FALSE;
	return *this;
}

str& str::operator>>(int s)
{
	mark_curr += s;
	if (mark_curr > string_len) mark_curr = string_len;
	mark_last = mark_curr;
	negative_flag = FALSE;
	return *this;
}

str& str::operator>=(int s)
{
	mark_curr += s;
	if (mark_curr > string_len) mark_curr = string_len;
	negative_flag = FALSE;
	return *this;
}

str& str::operator<=(int s)
{
	mark_curr -= s;
	if (mark_curr < 0) mark_curr = 0;
	negative_flag = FALSE;
	return *this;
}

/*
str& str::operator<<(char* x)
{
	str compare = str(x);
	SearchLeft(&compare);
	mark_last = mark_curr;
	return *this;
}*/

BOOL str::operator==(char* x)
{
	return operator==(str(x));
}

str& str::operator<<(char* x)
{
	return operator<<(str(x));
}

str& str::operator<=(char* x)
{
	return operator<=(str(x));
}

str& str::operator>>(char* x)
{
	return operator>>(str(x));
}

str& str::operator>=(char* x)
{
	return operator>=(str(x));
}

str& str::operator+(char* x)
{
	return operator+(str(x));
}

str& str::operator<<(str& x)
{
	SearchLeft(&x);
	mark_last = mark_curr;
	return *this;
}

/*
str& str::operator<=(char* x)
{
	str compare = str(x);
	SearchLeft(&compare);
	return *this;
}*/


str& str::operator<=(str& x)
{
	SearchLeft(&x);
	return *this;
}



/*
str& str::operator>>(char* x)
{
	str compare = str(x);
	SearchRight(&compare);
	mark_last = mark_curr;
	return *this;
}*/

str& str::operator>>(str& x)
{
	SearchRight(&x);
	mark_last = mark_curr;
	return *this;
}

/*
str& str::operator>=(char* x)
{
	str compare = str(x);
	SearchRight(&compare);
	return *this;
}*/

str& str::operator>=(str& x)
{
	SearchRight(&x);
	return *this;
}



BOOL str::operator==(str& compare)
{
	char* this_str = string + MarkStart();
	int this_len = MarkLen();

	char* cmp_str = compare.string + compare.MarkStart();
	int cmp_len = compare.MarkLen();

	if (!negative_flag)
		if (this_len != cmp_len) return FALSE;
	
	if (this_len < cmp_len) cmp_len = this_len;
	negative_flag = FALSE;

	while (cmp_len-->0)
		if (this_str[cmp_len] != cmp_str[cmp_len]) break;

	if (cmp_len<0) return TRUE;

	return FALSE;
}

str& str::operator+(str& x)
{
	int size1 = MarkLen();
	int size2 = x.MarkLen();
	int offset1 = MarkStart();
	int offset2 = x.MarkStart();

	mark_curr = 0;
	mark_last = size1+size2;
	string_len = mark_last;

	char* string2 = x.string;

	char* new_string = new char[mark_last+1];
	new_string[mark_last] = 0;
	char* new_string2 = new_string + size1;

	while (size1-->0) new_string[size1] = string[size1+offset1];
	while (size2-->0) new_string2[size2] = string2[size2+offset2];

	if (str_mem_allocated) delete string;

	string = new_string;
	str_mem_allocated = TRUE;
	negative_flag = FALSE;

	return *this;
}

void str::SearchLeft(str* compare)
{
	found = TRUE;

	char* cmp_str = compare->string + compare->MarkStart();
	int cmp_len = compare->MarkLen();

	if (string_len-mark_curr < cmp_len)
		mark_curr = string_len - cmp_len + 1;
	
	while (--mark_curr >= 0)
	{
		long c = cmp_len;
		while (c-->0)
			if (string[mark_curr+c] != cmp_str[c]) break;

		if (c<0)
		{
			if (negative_flag) mark_curr += cmp_len;
			negative_flag = FALSE;
			return;
		}
	}

	negative_flag = FALSE;
	mark_curr = 0;
	found = FALSE;
}

void str::SearchRight(str* compare)
{
	found = TRUE;

	char* cmp_str = compare->string + compare->MarkStart();
	int cmp_len = compare->MarkLen();

	int end = string_len-cmp_len;

	while (++mark_curr <= end)
	{
		long c = cmp_len;
		while (c-->0)
			if (string[mark_curr+c] != cmp_str[c]) break;

		if (c<0)
		{
			if (negative_flag) mark_curr += cmp_len;
			negative_flag = FALSE;
			return;
		}
	}

	negative_flag = FALSE;
	mark_curr = string_len;
	found = FALSE;
}

void str::KleinSchreibung()
{
	int c = MarkLen();
	int offs = MarkStart();

	while (c-->0)
		if (string[c+offs] & 0x40)
			string[c+offs] = (string[c+offs] & 0x1f) | 0x60;
}

void str::C64Schreibung()
{
	int c = MarkLen();
	int offs = MarkStart();

	while (c-->0)
	{
		char ch = string[c+offs];
		if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z'))
			string[c+offs] = ch ^ 0x20;
	}
}








	